#include "config.h"
#include "builtin.h"
#include "err.h"
#include "wtruntime/version.h"

static void builtin_version(struct wtr_context* ctx,
	struct wtr_extcallinfo* callinfo, wt_value* argv)
{
	wt_value retv[1];

	retv[0].writable_type = WTT_U32;
	retv[0].v_u32 = WTR_VERSION;

	wtrContextPushReturnValues(ctx, 1, retv);
}

static const wt_u32 a_u32[] = { WTT_U32 };

int wt_add_builtins(const char* const progname, wt_profile vm)
{
	wt_error err;

	if(WTE_OK!=(err=wtrProfileAddFunction(vm, "version", 0, NULL, 1, a_u32,
		builtin_version, NULL)))
	{
		goto error;
	}

	return 0;

error:;
	wt_display_error(progname, "failed to add builtin", err);
	return -1;
}
