// A Bison parser, made by GNU Bison 3.7.6.

// Skeleton interface for Bison LALR(1) parsers in C++

// Copyright (C) 2002-2015, 2018-2021 Free Software Foundation, Inc.

// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <https://www.gnu.org/licenses/>.

// As a special exception, you may create a larger work that contains
// part or all of the Bison parser skeleton and distribute that work
// under terms of your choice, so long as that work isn't itself a
// parser generator using the skeleton or a modified version thereof
// as a parser skeleton.  Alternatively, if you modify or redistribute
// the parser skeleton itself, you may (at your option) remove this
// special exception, which will cause the skeleton and the resulting
// Bison output files to be licensed under the GNU General Public
// License without this special exception.

// This special exception was added by the Free Software Foundation in
// version 2.2 of Bison.


/**
 ** \file parser.tab.hpp
 ** Define the wtparser::parser class.
 */

// C++ LALR(1) parser skeleton written by Akim Demaille.

// DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
// especially those whose name start with YY_ or yy_.  They are
// private implementation details that can be changed or removed.

#ifndef YY_YY_PARSER_TAB_HPP_INCLUDED
# define YY_YY_PARSER_TAB_HPP_INCLUDED
// "%code requires" blocks.
#line 12 "parser.y"

#include "parser_pre.h"
#include "ParserHelper.h"

#line 54 "parser.tab.hpp"


# include <cstdlib> // std::abort
# include <iostream>
# include <stdexcept>
# include <string>
# include <vector>

#if defined __cplusplus
# define YY_CPLUSPLUS __cplusplus
#else
# define YY_CPLUSPLUS 199711L
#endif

// Support move semantics when possible.
#if 201103L <= YY_CPLUSPLUS
# define YY_MOVE           std::move
# define YY_MOVE_OR_COPY   move
# define YY_MOVE_REF(Type) Type&&
# define YY_RVREF(Type)    Type&&
# define YY_COPY(Type)     Type
#else
# define YY_MOVE
# define YY_MOVE_OR_COPY   copy
# define YY_MOVE_REF(Type) Type&
# define YY_RVREF(Type)    const Type&
# define YY_COPY(Type)     const Type&
#endif

// Support noexcept when possible.
#if 201103L <= YY_CPLUSPLUS
# define YY_NOEXCEPT noexcept
# define YY_NOTHROW
#else
# define YY_NOEXCEPT
# define YY_NOTHROW throw ()
#endif

// Support constexpr when possible.
#if 201703 <= YY_CPLUSPLUS
# define YY_CONSTEXPR constexpr
#else
# define YY_CONSTEXPR
#endif
# include "location.hh"


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

#if defined __GNUC__ && ! defined __ICC && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                            \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

#line 9 "parser.y"
namespace wtparser {
#line 184 "parser.tab.hpp"




  /// A Bison parser.
  class WTParser
  {
  public:
#ifndef YYSTYPE
    /// Symbol semantic values.
    union semantic_type
    {
#line 247 "parser.y"

	wt_i8                         integer8;
	wt_u8                         unsigned8;
	wt_i16                        integer16;
	wt_u16                        unsigned16;
	wt_i32                        integer32;
	wt_u32                        unsigned32;
	wt_i64                        integer64;
	wt_u64                        unsigned64;
	bool                          logical;
	std::string*                  str;
	wtast::Entity*                entity;
	wtast::Metadata*              metadata;
	wtast::Block*                 block;
	wtast::ExceptionCompound*     exceptioncompound;
	wtast::EHandlers*             ehandlers;
	wtast::Finally*               finally;
	wtast::Compound*              compound;
	wtast::Statement*             statement;
	wtast::VariableDeclaration*   variabledeclaration;
	wtast::Type*                  type;
	wtast::Expression*            expression;
	wtast::LValue*                lvalue;
	wtast::Assignment*            assignment;
	wtast::FunctionArgument*      functionargument;
	wtast::FunctionSignature*     functionsignature;
	wtast::Declaration*           declaration;
	wtast::RecordField*           recordfield;
	wtast::DataType*              datatype;
	wtast::DataTypeCons*          datatypecons;
	wtast::PreCondition*          precond;
	wtast::PostCondition*         postcond;
	wtast::FieldAssign*           fieldassign;
	wtast::DefaultStatement*      defaultstatement;
	wtast::EnumType*              enumtype;
	wtast::Enumerator*            enumerator;
	wtast::SwitchCase*            switchcase;
	statements_t*                 statements;
	entities_t*                   entities;
	throptions_t*                 throptions;
	ehandlerlist_t*               ehandlerlist;
	declarations_t*               declarations;
	recordfields_t*               recordfields;
	datatypeconses_t*             datatypeconses;
	variabledecls_t*              variabledecls;
	identlist_t*                  identlist;
	fieldassigns_t*               fieldassigns;
	enumerators_t*                enumerators;
	switchcases_t*                switchcases;

#line 248 "parser.tab.hpp"

    };
#else
    typedef YYSTYPE semantic_type;
#endif
    /// Symbol locations.
    typedef location location_type;

    /// Syntax errors thrown from user actions.
    struct syntax_error : std::runtime_error
    {
      syntax_error (const location_type& l, const std::string& m)
        : std::runtime_error (m)
        , location (l)
      {}

      syntax_error (const syntax_error& s)
        : std::runtime_error (s.what ())
        , location (s.location)
      {}

      ~syntax_error () YY_NOEXCEPT YY_NOTHROW;

      location_type location;
    };

    /// Token kinds.
    struct token
    {
      enum token_kind_type
      {
        YYEMPTY = -2,
    END = 0,                       // "end of file"
    YYerror = 256,                 // error
    YYUNDEF = 257,                 // "invalid token"
    OPT_DSS = 258,                 // OPT_DSS
    OPT_CSS = 259,                 // OPT_CSS
    TYPE_CHAR = 260,               // TYPE_CHAR
    TYPE_BOOL = 261,               // TYPE_BOOL
    TYPE_HANDLE = 262,             // TYPE_HANDLE
    TYPE_I8 = 263,                 // TYPE_I8
    TYPE_U8 = 264,                 // TYPE_U8
    TYPE_I16 = 265,                // TYPE_I16
    TYPE_U16 = 266,                // TYPE_U16
    TYPE_I32 = 267,                // TYPE_I32
    TYPE_U32 = 268,                // TYPE_U32
    TYPE_I64 = 269,                // TYPE_I64
    TYPE_U64 = 270,                // TYPE_U64
    TYPE_F32 = 271,                // TYPE_F32
    TYPE_F64 = 272,                // TYPE_F64
    KW_SEQ = 273,                  // KW_SEQ
    TYPE_STRING = 274,             // TYPE_STRING
    TYPE_FILE = 275,               // TYPE_FILE
    TYPE_DIR = 276,                // TYPE_DIR
    TYPE_SOCKET = 277,             // TYPE_SOCKET
    KW_TRUE = 278,                 // KW_TRUE
    KW_FALSE = 279,                // KW_FALSE
    KW_FUNCTION = 280,             // KW_FUNCTION
    KW_EXCEPTION = 281,            // KW_EXCEPTION
    KW_RAISE = 282,                // KW_RAISE
    KW_RAISENEAR = 283,            // KW_RAISENEAR
    KW_FINALLY = 284,              // KW_FINALLY
    KW_RETURN = 285,               // KW_RETURN
    KW_MAIN = 286,                 // KW_MAIN
    KW_CTOR = 287,                 // KW_CTOR
    KW_DTOR = 288,                 // KW_DTOR
    KW_GLOBAL = 289,               // KW_GLOBAL
    KW_IMPORT = 290,               // KW_IMPORT
    KW_EXPORT = 291,               // KW_EXPORT
    KW_DECLARE = 292,              // KW_DECLARE
    KW_MUTABLE = 293,              // KW_MUTABLE
    KW_DO = 294,                   // KW_DO
    KW_IF = 295,                   // KW_IF
    KW_ELSE = 296,                 // KW_ELSE
    KW_ELIF = 297,                 // KW_ELIF
    KW_FOR = 298,                  // KW_FOR
    KW_FOREACH = 299,              // KW_FOREACH
    KW_WHILE = 300,                // KW_WHILE
    KW_IN = 301,                   // KW_IN
    KW_INCLUSIVE = 302,            // KW_INCLUSIVE
    KW_EXCLUSIVE = 303,            // KW_EXCLUSIVE
    KW_REVERSE = 304,              // KW_REVERSE
    KW_WHICH = 305,                // KW_WHICH
    KW_RECORD = 306,               // KW_RECORD
    KW_PRE = 307,                  // KW_PRE
    KW_POST = 308,                 // KW_POST
    KW_ASSERT = 309,               // KW_ASSERT
    KW_LIMITED = 310,              // KW_LIMITED
    KW_PRIVATE = 311,              // KW_PRIVATE
    KW_OPERATOR = 312,             // KW_OPERATOR
    KW_ALIAS = 313,                // KW_ALIAS
    KW_PURE = 314,                 // KW_PURE
    KW_IMPURE = 315,               // KW_IMPURE
    KW_OLD = 316,                  // KW_OLD
    KW_DATATYPE = 317,             // KW_DATATYPE
    KW_SWITCH = 318,               // KW_SWITCH
    KW_CASE = 319,                 // KW_CASE
    KW_DEFAULT = 320,              // KW_DEFAULT
    KW_BREAK = 321,                // KW_BREAK
    KW_TYPE = 322,                 // KW_TYPE
    KW_ENUM = 323,                 // KW_ENUM
    SEMICOLON = 324,               // SEMICOLON
    COLON = 325,                   // COLON
    COLONCOLON = 326,              // COLONCOLON
    DOT = 327,                     // DOT
    DOTDOT = 328,                  // DOTDOT
    DOTDOTDOT = 329,               // DOTDOTDOT
    ASSIGN = 330,                  // ASSIGN
    LPAR = 331,                    // LPAR
    RPAR = 332,                    // RPAR
    LBRACKET = 333,                // LBRACKET
    RBRACKET = 334,                // RBRACKET
    LBRACE = 335,                  // LBRACE
    RBRACE = 336,                  // RBRACE
    META_AUTHOR = 337,             // META_AUTHOR
    META_TITLE = 338,              // META_TITLE
    META_VERSION = 339,            // META_VERSION
    META_COPYRIGHT = 340,          // META_COPYRIGHT
    META_ID = 341,                 // META_ID
    META_COMMENT = 342,            // META_COMMENT
    META__CUSTOM = 343,            // META__CUSTOM
    PREDEF_FILE = 344,             // PREDEF_FILE
    PREDEF_LINE = 345,             // PREDEF_LINE
    PREDEF_DATE = 346,             // PREDEF_DATE
    PREDEF_TIME = 347,             // PREDEF_TIME
    PREDEF_DATETIME = 348,         // PREDEF_DATETIME
    CHARLIT = 349,                 // CHARLIT
    STRINGLIT = 350,               // STRINGLIT
    IDENTIFIER = 351,              // IDENTIFIER
    TYPENAME = 352,                // TYPENAME
    SPECIALIDENT = 353,            // SPECIALIDENT
    FLOATNUMBER = 354,             // FLOATNUMBER
    DOUBLENUMBER = 355,            // DOUBLENUMBER
    I8DEC = 356,                   // I8DEC
    U8DEC = 357,                   // U8DEC
    I16DEC = 358,                  // I16DEC
    U16DEC = 359,                  // U16DEC
    I32DEC = 360,                  // I32DEC
    U32DEC = 361,                  // U32DEC
    I64DEC = 362,                  // I64DEC
    U64DEC = 363,                  // U64DEC
    I8HEX = 364,                   // I8HEX
    U8HEX = 365,                   // U8HEX
    I16HEX = 366,                  // I16HEX
    U16HEX = 367,                  // U16HEX
    I32HEX = 368,                  // I32HEX
    U32HEX = 369,                  // U32HEX
    I64HEX = 370,                  // I64HEX
    U64HEX = 371,                  // U64HEX
    I8BIN = 372,                   // I8BIN
    U8BIN = 373,                   // U8BIN
    I16BIN = 374,                  // I16BIN
    U16BIN = 375,                  // U16BIN
    I32BIN = 376,                  // I32BIN
    U32BIN = 377,                  // U32BIN
    I64BIN = 378,                  // I64BIN
    U64BIN = 379,                  // U64BIN
    I8OCT = 380,                   // I8OCT
    U8OCT = 381,                   // U8OCT
    I16OCT = 382,                  // I16OCT
    U16OCT = 383,                  // U16OCT
    I32OCT = 384,                  // I32OCT
    U32OCT = 385,                  // U32OCT
    I64OCT = 386,                  // I64OCT
    U64OCT = 387,                  // U64OCT
    UNBOUNDOPERATOR = 388,         // UNBOUNDOPERATOR
    COMMA = 389,                   // COMMA
    OP_LEFT03 = 390,               // OP_LEFT03
    OP_LORELSE = 391,              // OP_LORELSE
    OP_RIGHT03 = 392,              // OP_RIGHT03
    OP_LEFT04 = 393,               // OP_LEFT04
    OP_LANDTHEN = 394,             // OP_LANDTHEN
    OP_RIGHT04 = 395,              // OP_RIGHT04
    OP_LEFT05 = 396,               // OP_LEFT05
    OP_RIGHT05 = 397,              // OP_RIGHT05
    OP_LEFT06 = 398,               // OP_LEFT06
    OP_RIGHT06 = 399,              // OP_RIGHT06
    OP_LEFT07 = 400,               // OP_LEFT07
    OP_RIGHT07 = 401,              // OP_RIGHT07
    OP_LEFT08 = 402,               // OP_LEFT08
    OP_RIGHT08 = 403,              // OP_RIGHT08
    OP_LEFT09 = 404,               // OP_LEFT09
    OP_RIGHT09 = 405,              // OP_RIGHT09
    OP_LEFT10 = 406,               // OP_LEFT10
    OP_RIGHT10 = 407,              // OP_RIGHT10
    OP_LEFT11 = 408,               // OP_LEFT11
    LANGLEBRACKET = 409,           // LANGLEBRACKET
    RANGLEBRACKET = 410,           // RANGLEBRACKET
    OP_RIGHT11 = 411,              // OP_RIGHT11
    OP_LEFT12 = 412,               // OP_LEFT12
    OP_RIGHT12 = 413,              // OP_RIGHT12
    OP_LEFT13 = 414,               // OP_LEFT13
    OP_RIGHT13 = 415,              // OP_RIGHT13
    OP_LEFT14 = 416,               // OP_LEFT14
    OP_RIGHT14 = 417,              // OP_RIGHT14
    OP_LEFT15 = 418,               // OP_LEFT15
    OP_RIGHT15 = 419               // OP_RIGHT15
      };
      /// Backward compatibility alias (Bison 3.6).
      typedef token_kind_type yytokentype;
    };

    /// Token kind, as returned by yylex.
    typedef token::yytokentype token_kind_type;

    /// Backward compatibility alias (Bison 3.6).
    typedef token_kind_type token_type;

    /// Symbol kinds.
    struct symbol_kind
    {
      enum symbol_kind_type
      {
        YYNTOKENS = 165, ///< Number of tokens.
        S_YYEMPTY = -2,
        S_YYEOF = 0,                             // "end of file"
        S_YYerror = 1,                           // error
        S_YYUNDEF = 2,                           // "invalid token"
        S_OPT_DSS = 3,                           // OPT_DSS
        S_OPT_CSS = 4,                           // OPT_CSS
        S_TYPE_CHAR = 5,                         // TYPE_CHAR
        S_TYPE_BOOL = 6,                         // TYPE_BOOL
        S_TYPE_HANDLE = 7,                       // TYPE_HANDLE
        S_TYPE_I8 = 8,                           // TYPE_I8
        S_TYPE_U8 = 9,                           // TYPE_U8
        S_TYPE_I16 = 10,                         // TYPE_I16
        S_TYPE_U16 = 11,                         // TYPE_U16
        S_TYPE_I32 = 12,                         // TYPE_I32
        S_TYPE_U32 = 13,                         // TYPE_U32
        S_TYPE_I64 = 14,                         // TYPE_I64
        S_TYPE_U64 = 15,                         // TYPE_U64
        S_TYPE_F32 = 16,                         // TYPE_F32
        S_TYPE_F64 = 17,                         // TYPE_F64
        S_KW_SEQ = 18,                           // KW_SEQ
        S_TYPE_STRING = 19,                      // TYPE_STRING
        S_TYPE_FILE = 20,                        // TYPE_FILE
        S_TYPE_DIR = 21,                         // TYPE_DIR
        S_TYPE_SOCKET = 22,                      // TYPE_SOCKET
        S_KW_TRUE = 23,                          // KW_TRUE
        S_KW_FALSE = 24,                         // KW_FALSE
        S_KW_FUNCTION = 25,                      // KW_FUNCTION
        S_KW_EXCEPTION = 26,                     // KW_EXCEPTION
        S_KW_RAISE = 27,                         // KW_RAISE
        S_KW_RAISENEAR = 28,                     // KW_RAISENEAR
        S_KW_FINALLY = 29,                       // KW_FINALLY
        S_KW_RETURN = 30,                        // KW_RETURN
        S_KW_MAIN = 31,                          // KW_MAIN
        S_KW_CTOR = 32,                          // KW_CTOR
        S_KW_DTOR = 33,                          // KW_DTOR
        S_KW_GLOBAL = 34,                        // KW_GLOBAL
        S_KW_IMPORT = 35,                        // KW_IMPORT
        S_KW_EXPORT = 36,                        // KW_EXPORT
        S_KW_DECLARE = 37,                       // KW_DECLARE
        S_KW_MUTABLE = 38,                       // KW_MUTABLE
        S_KW_DO = 39,                            // KW_DO
        S_KW_IF = 40,                            // KW_IF
        S_KW_ELSE = 41,                          // KW_ELSE
        S_KW_ELIF = 42,                          // KW_ELIF
        S_KW_FOR = 43,                           // KW_FOR
        S_KW_FOREACH = 44,                       // KW_FOREACH
        S_KW_WHILE = 45,                         // KW_WHILE
        S_KW_IN = 46,                            // KW_IN
        S_KW_INCLUSIVE = 47,                     // KW_INCLUSIVE
        S_KW_EXCLUSIVE = 48,                     // KW_EXCLUSIVE
        S_KW_REVERSE = 49,                       // KW_REVERSE
        S_KW_WHICH = 50,                         // KW_WHICH
        S_KW_RECORD = 51,                        // KW_RECORD
        S_KW_PRE = 52,                           // KW_PRE
        S_KW_POST = 53,                          // KW_POST
        S_KW_ASSERT = 54,                        // KW_ASSERT
        S_KW_LIMITED = 55,                       // KW_LIMITED
        S_KW_PRIVATE = 56,                       // KW_PRIVATE
        S_KW_OPERATOR = 57,                      // KW_OPERATOR
        S_KW_ALIAS = 58,                         // KW_ALIAS
        S_KW_PURE = 59,                          // KW_PURE
        S_KW_IMPURE = 60,                        // KW_IMPURE
        S_KW_OLD = 61,                           // KW_OLD
        S_KW_DATATYPE = 62,                      // KW_DATATYPE
        S_KW_SWITCH = 63,                        // KW_SWITCH
        S_KW_CASE = 64,                          // KW_CASE
        S_KW_DEFAULT = 65,                       // KW_DEFAULT
        S_KW_BREAK = 66,                         // KW_BREAK
        S_KW_TYPE = 67,                          // KW_TYPE
        S_KW_ENUM = 68,                          // KW_ENUM
        S_SEMICOLON = 69,                        // SEMICOLON
        S_COLON = 70,                            // COLON
        S_COLONCOLON = 71,                       // COLONCOLON
        S_DOT = 72,                              // DOT
        S_DOTDOT = 73,                           // DOTDOT
        S_DOTDOTDOT = 74,                        // DOTDOTDOT
        S_ASSIGN = 75,                           // ASSIGN
        S_LPAR = 76,                             // LPAR
        S_RPAR = 77,                             // RPAR
        S_LBRACKET = 78,                         // LBRACKET
        S_RBRACKET = 79,                         // RBRACKET
        S_LBRACE = 80,                           // LBRACE
        S_RBRACE = 81,                           // RBRACE
        S_META_AUTHOR = 82,                      // META_AUTHOR
        S_META_TITLE = 83,                       // META_TITLE
        S_META_VERSION = 84,                     // META_VERSION
        S_META_COPYRIGHT = 85,                   // META_COPYRIGHT
        S_META_ID = 86,                          // META_ID
        S_META_COMMENT = 87,                     // META_COMMENT
        S_META__CUSTOM = 88,                     // META__CUSTOM
        S_PREDEF_FILE = 89,                      // PREDEF_FILE
        S_PREDEF_LINE = 90,                      // PREDEF_LINE
        S_PREDEF_DATE = 91,                      // PREDEF_DATE
        S_PREDEF_TIME = 92,                      // PREDEF_TIME
        S_PREDEF_DATETIME = 93,                  // PREDEF_DATETIME
        S_CHARLIT = 94,                          // CHARLIT
        S_STRINGLIT = 95,                        // STRINGLIT
        S_IDENTIFIER = 96,                       // IDENTIFIER
        S_TYPENAME = 97,                         // TYPENAME
        S_SPECIALIDENT = 98,                     // SPECIALIDENT
        S_FLOATNUMBER = 99,                      // FLOATNUMBER
        S_DOUBLENUMBER = 100,                    // DOUBLENUMBER
        S_I8DEC = 101,                           // I8DEC
        S_U8DEC = 102,                           // U8DEC
        S_I16DEC = 103,                          // I16DEC
        S_U16DEC = 104,                          // U16DEC
        S_I32DEC = 105,                          // I32DEC
        S_U32DEC = 106,                          // U32DEC
        S_I64DEC = 107,                          // I64DEC
        S_U64DEC = 108,                          // U64DEC
        S_I8HEX = 109,                           // I8HEX
        S_U8HEX = 110,                           // U8HEX
        S_I16HEX = 111,                          // I16HEX
        S_U16HEX = 112,                          // U16HEX
        S_I32HEX = 113,                          // I32HEX
        S_U32HEX = 114,                          // U32HEX
        S_I64HEX = 115,                          // I64HEX
        S_U64HEX = 116,                          // U64HEX
        S_I8BIN = 117,                           // I8BIN
        S_U8BIN = 118,                           // U8BIN
        S_I16BIN = 119,                          // I16BIN
        S_U16BIN = 120,                          // U16BIN
        S_I32BIN = 121,                          // I32BIN
        S_U32BIN = 122,                          // U32BIN
        S_I64BIN = 123,                          // I64BIN
        S_U64BIN = 124,                          // U64BIN
        S_I8OCT = 125,                           // I8OCT
        S_U8OCT = 126,                           // U8OCT
        S_I16OCT = 127,                          // I16OCT
        S_U16OCT = 128,                          // U16OCT
        S_I32OCT = 129,                          // I32OCT
        S_U32OCT = 130,                          // U32OCT
        S_I64OCT = 131,                          // I64OCT
        S_U64OCT = 132,                          // U64OCT
        S_UNBOUNDOPERATOR = 133,                 // UNBOUNDOPERATOR
        S_COMMA = 134,                           // COMMA
        S_OP_LEFT03 = 135,                       // OP_LEFT03
        S_OP_LORELSE = 136,                      // OP_LORELSE
        S_OP_RIGHT03 = 137,                      // OP_RIGHT03
        S_OP_LEFT04 = 138,                       // OP_LEFT04
        S_OP_LANDTHEN = 139,                     // OP_LANDTHEN
        S_OP_RIGHT04 = 140,                      // OP_RIGHT04
        S_OP_LEFT05 = 141,                       // OP_LEFT05
        S_OP_RIGHT05 = 142,                      // OP_RIGHT05
        S_OP_LEFT06 = 143,                       // OP_LEFT06
        S_OP_RIGHT06 = 144,                      // OP_RIGHT06
        S_OP_LEFT07 = 145,                       // OP_LEFT07
        S_OP_RIGHT07 = 146,                      // OP_RIGHT07
        S_OP_LEFT08 = 147,                       // OP_LEFT08
        S_OP_RIGHT08 = 148,                      // OP_RIGHT08
        S_OP_LEFT09 = 149,                       // OP_LEFT09
        S_OP_RIGHT09 = 150,                      // OP_RIGHT09
        S_OP_LEFT10 = 151,                       // OP_LEFT10
        S_OP_RIGHT10 = 152,                      // OP_RIGHT10
        S_OP_LEFT11 = 153,                       // OP_LEFT11
        S_LANGLEBRACKET = 154,                   // LANGLEBRACKET
        S_RANGLEBRACKET = 155,                   // RANGLEBRACKET
        S_OP_RIGHT11 = 156,                      // OP_RIGHT11
        S_OP_LEFT12 = 157,                       // OP_LEFT12
        S_OP_RIGHT12 = 158,                      // OP_RIGHT12
        S_OP_LEFT13 = 159,                       // OP_LEFT13
        S_OP_RIGHT13 = 160,                      // OP_RIGHT13
        S_OP_LEFT14 = 161,                       // OP_LEFT14
        S_OP_RIGHT14 = 162,                      // OP_RIGHT14
        S_OP_LEFT15 = 163,                       // OP_LEFT15
        S_OP_RIGHT15 = 164,                      // OP_RIGHT15
        S_YYACCEPT = 165,                        // $accept
        S_start = 166,                           // start
        S_entities = 167,                        // entities
        S_entity = 168,                          // entity
        S_169_1 = 169,                           // $@1
        S_170_2 = 170,                           // $@2
        S_171_3 = 171,                           // $@3
        S_172_4 = 172,                           // $@4
        S_metadata = 173,                        // metadata
        S_string = 174,                          // string
        S_stringlit = 175,                       // stringlit
        S_block = 176,                           // block
        S_177_5 = 177,                           // $@5
        S_178_6 = 178,                           // $@6
        S_179_7 = 179,                           // $@7
        S_180_8 = 180,                           // $@8
        S_attributes = 181,                      // attributes
        S_precond = 182,                         // precond
        S_postcond = 183,                        // postcond
        S_184_9 = 184,                           // @9
        S_185_10 = 185,                          // @10
        S_identlist = 186,                       // identlist
        S_identlist_opt = 187,                   // identlist_opt
        S_declarations = 188,                    // declarations
        S_declaration = 189,                     // declaration
        S_190_11 = 190,                          // @11
        S_191_12 = 191,                          // @12
        S_recordfields = 192,                    // recordfields
        S_recordfield = 193,                     // recordfield
        S_enumerators = 194,                     // enumerators
        S_enumerator = 195,                      // enumerator
        S_datatypeconses = 196,                  // datatypeconses
        S_datatypeconsname = 197,                // datatypeconsname
        S_datatypecons = 198,                    // datatypecons
        S_datatypecons_builder = 199,            // datatypecons_builder
        S_exceptioncompound = 200,               // exceptioncompound
        S_201_13 = 201,                          // $@13
        S_throptions = 202,                      // throptions
        S_throptionlist = 203,                   // throptionlist
        S_integer8 = 204,                        // integer8
        S_unsigned8 = 205,                       // unsigned8
        S_integer16 = 206,                       // integer16
        S_unsigned16 = 207,                      // unsigned16
        S_integer32 = 208,                       // integer32
        S_unsigned32 = 209,                      // unsigned32
        S_integer64 = 210,                       // integer64
        S_unsigned64 = 211,                      // unsigned64
        S_ehandlers = 212,                       // ehandlers
        S_ehandlerlist = 213,                    // ehandlerlist
        S_finally = 214,                         // finally
        S_215_14 = 215,                          // $@14
        S_functionargument = 216,                // functionargument
        S_functionsignature = 217,               // functionsignature
        S_funcsig_start = 218,                   // funcsig_start
        S_funcsig_args = 219,                    // funcsig_args
        S_funcsig_rets = 220,                    // funcsig_rets
        S_compound = 221,                        // compound
        S_222_15 = 222,                          // $@15
        S_223_16 = 223,                          // $@16
        S_statements = 224,                      // statements
        S_statement = 225,                       // statement
        S_226_17 = 226,                          // @17
        S_227_18 = 227,                          // @18
        S_228_19 = 228,                          // $@19
        S_elsestatement = 229,                   // elsestatement
        S_foreach_while = 230,                   // foreach_while
        S_foreach_which = 231,                   // foreach_which
        S_inclusive_opt = 232,                   // inclusive_opt
        S_reverse_opt = 233,                     // reverse_opt
        S_switchcases = 234,                     // switchcases
        S_switchcase = 235,                      // switchcase
        S_236_20 = 236,                          // @20
        S_237_21 = 237,                          // @21
        S_default_opt = 238,                     // default_opt
        S_variabledeclaration = 239,             // variabledeclaration
        S_variabledeclarations = 240,            // variabledeclarations
        S_type = 241,                            // type
        S_expression_opt = 242,                  // expression_opt
        S_expression = 243,                      // expression
        S_funccallexpr = 244,                    // funccallexpr
        S_lvalue = 245,                          // lvalue
        S_assignment_opt = 246,                  // assignment_opt
        S_assignment = 247,                      // assignment
        S_assignment_builder = 248,              // assignment_builder
        S_fieldassigns = 249,                    // fieldassigns
        S_fieldassign = 250                      // fieldassign
      };
    };

    /// (Internal) symbol kind.
    typedef symbol_kind::symbol_kind_type symbol_kind_type;

    /// The number of tokens.
    static const symbol_kind_type YYNTOKENS = symbol_kind::YYNTOKENS;

    /// A complete symbol.
    ///
    /// Expects its Base type to provide access to the symbol kind
    /// via kind ().
    ///
    /// Provide access to semantic value and location.
    template <typename Base>
    struct basic_symbol : Base
    {
      /// Alias to Base.
      typedef Base super_type;

      /// Default constructor.
      basic_symbol ()
        : value ()
        , location ()
      {}

#if 201103L <= YY_CPLUSPLUS
      /// Move constructor.
      basic_symbol (basic_symbol&& that)
        : Base (std::move (that))
        , value (std::move (that.value))
        , location (std::move (that.location))
      {}
#endif

      /// Copy constructor.
      basic_symbol (const basic_symbol& that);
      /// Constructor for valueless symbols.
      basic_symbol (typename Base::kind_type t,
                    YY_MOVE_REF (location_type) l);

      /// Constructor for symbols with semantic value.
      basic_symbol (typename Base::kind_type t,
                    YY_RVREF (semantic_type) v,
                    YY_RVREF (location_type) l);

      /// Destroy the symbol.
      ~basic_symbol ()
      {
        clear ();
      }

      /// Destroy contents, and record that is empty.
      void clear () YY_NOEXCEPT
      {
        Base::clear ();
      }

#if YYDEBUG || 0
      /// The user-facing name of this symbol.
      const char *name () const YY_NOEXCEPT
      {
        return WTParser::symbol_name (this->kind ());
      }
#endif // #if YYDEBUG || 0


      /// Backward compatibility (Bison 3.6).
      symbol_kind_type type_get () const YY_NOEXCEPT;

      /// Whether empty.
      bool empty () const YY_NOEXCEPT;

      /// Destructive move, \a s is emptied into this.
      void move (basic_symbol& s);

      /// The semantic value.
      semantic_type value;

      /// The location.
      location_type location;

    private:
#if YY_CPLUSPLUS < 201103L
      /// Assignment operator.
      basic_symbol& operator= (const basic_symbol& that);
#endif
    };

    /// Type access provider for token (enum) based symbols.
    struct by_kind
    {
      /// Default constructor.
      by_kind ();

#if 201103L <= YY_CPLUSPLUS
      /// Move constructor.
      by_kind (by_kind&& that);
#endif

      /// Copy constructor.
      by_kind (const by_kind& that);

      /// The symbol kind as needed by the constructor.
      typedef token_kind_type kind_type;

      /// Constructor from (external) token numbers.
      by_kind (kind_type t);

      /// Record that this symbol is empty.
      void clear () YY_NOEXCEPT;

      /// Steal the symbol kind from \a that.
      void move (by_kind& that);

      /// The (internal) type number (corresponding to \a type).
      /// \a empty when empty.
      symbol_kind_type kind () const YY_NOEXCEPT;

      /// Backward compatibility (Bison 3.6).
      symbol_kind_type type_get () const YY_NOEXCEPT;

      /// The symbol kind.
      /// \a S_YYEMPTY when empty.
      symbol_kind_type kind_;
    };

    /// Backward compatibility for a private implementation detail (Bison 3.6).
    typedef by_kind by_type;

    /// "External" symbols: returned by the scanner.
    struct symbol_type : basic_symbol<by_kind>
    {};

    /// Build a parser object.
    WTParser (ParserHelper & helper_yyarg);
    virtual ~WTParser ();

#if 201103L <= YY_CPLUSPLUS
    /// Non copyable.
    WTParser (const WTParser&) = delete;
    /// Non copyable.
    WTParser& operator= (const WTParser&) = delete;
#endif

    /// Parse.  An alias for parse ().
    /// \returns  0 iff parsing succeeded.
    int operator() ();

    /// Parse.
    /// \returns  0 iff parsing succeeded.
    virtual int parse ();

#if YYDEBUG
    /// The current debugging stream.
    std::ostream& debug_stream () const YY_ATTRIBUTE_PURE;
    /// Set the current debugging stream.
    void set_debug_stream (std::ostream &);

    /// Type for debugging levels.
    typedef int debug_level_type;
    /// The current debugging level.
    debug_level_type debug_level () const YY_ATTRIBUTE_PURE;
    /// Set the current debugging level.
    void set_debug_level (debug_level_type l);
#endif

    /// Report a syntax error.
    /// \param loc    where the syntax error is found.
    /// \param msg    a description of the syntax error.
    virtual void error (const location_type& loc, const std::string& msg);

    /// Report a syntax error.
    void error (const syntax_error& err);

#if YYDEBUG || 0
    /// The user-facing name of the symbol whose (internal) number is
    /// YYSYMBOL.  No bounds checking.
    static const char *symbol_name (symbol_kind_type yysymbol);
#endif // #if YYDEBUG || 0




  private:
#if YY_CPLUSPLUS < 201103L
    /// Non copyable.
    WTParser (const WTParser&);
    /// Non copyable.
    WTParser& operator= (const WTParser&);
#endif


    /// Stored state numbers (used for stacks).
    typedef short state_type;

    /// Compute post-reduction state.
    /// \param yystate   the current state
    /// \param yysym     the nonterminal to push on the stack
    static state_type yy_lr_goto_state_ (state_type yystate, int yysym);

    /// Whether the given \c yypact_ value indicates a defaulted state.
    /// \param yyvalue   the value to check
    static bool yy_pact_value_is_default_ (int yyvalue);

    /// Whether the given \c yytable_ value indicates a syntax error.
    /// \param yyvalue   the value to check
    static bool yy_table_value_is_error_ (int yyvalue);

    static const short yypact_ninf_;
    static const signed char yytable_ninf_;

    /// Convert a scanner token kind \a t to a symbol kind.
    /// In theory \a t should be a token_kind_type, but character literals
    /// are valid, yet not members of the token_type enum.
    static symbol_kind_type yytranslate_ (int t);

#if YYDEBUG || 0
    /// For a symbol, its name in clear.
    static const char* const yytname_[];
#endif // #if YYDEBUG || 0


    // Tables.
    // YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
    // STATE-NUM.
    static const short yypact_[];

    // YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
    // Performed when YYTABLE does not specify something else to do.  Zero
    // means the default is an error.
    static const short yydefact_[];

    // YYPGOTO[NTERM-NUM].
    static const short yypgoto_[];

    // YYDEFGOTO[NTERM-NUM].
    static const short yydefgoto_[];

    // YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
    // positive, shift that token.  If negative, reduce the rule whose
    // number is the opposite.  If YYTABLE_NINF, syntax error.
    static const short yytable_[];

    static const short yycheck_[];

    // YYSTOS[STATE-NUM] -- The (internal number of the) accessing
    // symbol of state STATE-NUM.
    static const unsigned char yystos_[];

    // YYR1[YYN] -- Symbol number of symbol that rule YYN derives.
    static const unsigned char yyr1_[];

    // YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.
    static const signed char yyr2_[];


#if YYDEBUG
    // YYRLINE[YYN] -- Source line where rule number YYN was defined.
    static const short yyrline_[];
    /// Report on the debug stream that the rule \a r is going to be reduced.
    virtual void yy_reduce_print_ (int r) const;
    /// Print the state stack on the debug stream.
    virtual void yy_stack_print_ () const;

    /// Debugging level.
    int yydebug_;
    /// Debug stream.
    std::ostream* yycdebug_;

    /// \brief Display a symbol kind, value and location.
    /// \param yyo    The output stream.
    /// \param yysym  The symbol.
    template <typename Base>
    void yy_print_ (std::ostream& yyo, const basic_symbol<Base>& yysym) const;
#endif

    /// \brief Reclaim the memory associated to a symbol.
    /// \param yymsg     Why this token is reclaimed.
    ///                  If null, print nothing.
    /// \param yysym     The symbol.
    template <typename Base>
    void yy_destroy_ (const char* yymsg, basic_symbol<Base>& yysym) const;

  private:
    /// Type access provider for state based symbols.
    struct by_state
    {
      /// Default constructor.
      by_state () YY_NOEXCEPT;

      /// The symbol kind as needed by the constructor.
      typedef state_type kind_type;

      /// Constructor.
      by_state (kind_type s) YY_NOEXCEPT;

      /// Copy constructor.
      by_state (const by_state& that) YY_NOEXCEPT;

      /// Record that this symbol is empty.
      void clear () YY_NOEXCEPT;

      /// Steal the symbol kind from \a that.
      void move (by_state& that);

      /// The symbol kind (corresponding to \a state).
      /// \a symbol_kind::S_YYEMPTY when empty.
      symbol_kind_type kind () const YY_NOEXCEPT;

      /// The state number used to denote an empty symbol.
      /// We use the initial state, as it does not have a value.
      enum { empty_state = 0 };

      /// The state.
      /// \a empty when empty.
      state_type state;
    };

    /// "Internal" symbol: element of the stack.
    struct stack_symbol_type : basic_symbol<by_state>
    {
      /// Superclass.
      typedef basic_symbol<by_state> super_type;
      /// Construct an empty symbol.
      stack_symbol_type ();
      /// Move or copy construction.
      stack_symbol_type (YY_RVREF (stack_symbol_type) that);
      /// Steal the contents from \a sym to build this.
      stack_symbol_type (state_type s, YY_MOVE_REF (symbol_type) sym);
#if YY_CPLUSPLUS < 201103L
      /// Assignment, needed by push_back by some old implementations.
      /// Moves the contents of that.
      stack_symbol_type& operator= (stack_symbol_type& that);

      /// Assignment, needed by push_back by other implementations.
      /// Needed by some other old implementations.
      stack_symbol_type& operator= (const stack_symbol_type& that);
#endif
    };

    /// A stack with random access from its top.
    template <typename T, typename S = std::vector<T> >
    class stack
    {
    public:
      // Hide our reversed order.
      typedef typename S::iterator iterator;
      typedef typename S::const_iterator const_iterator;
      typedef typename S::size_type size_type;
      typedef typename std::ptrdiff_t index_type;

      stack (size_type n = 200)
        : seq_ (n)
      {}

#if 201103L <= YY_CPLUSPLUS
      /// Non copyable.
      stack (const stack&) = delete;
      /// Non copyable.
      stack& operator= (const stack&) = delete;
#endif

      /// Random access.
      ///
      /// Index 0 returns the topmost element.
      const T&
      operator[] (index_type i) const
      {
        return seq_[size_type (size () - 1 - i)];
      }

      /// Random access.
      ///
      /// Index 0 returns the topmost element.
      T&
      operator[] (index_type i)
      {
        return seq_[size_type (size () - 1 - i)];
      }

      /// Steal the contents of \a t.
      ///
      /// Close to move-semantics.
      void
      push (YY_MOVE_REF (T) t)
      {
        seq_.push_back (T ());
        operator[] (0).move (t);
      }

      /// Pop elements from the stack.
      void
      pop (std::ptrdiff_t n = 1) YY_NOEXCEPT
      {
        for (; 0 < n; --n)
          seq_.pop_back ();
      }

      /// Pop all elements from the stack.
      void
      clear () YY_NOEXCEPT
      {
        seq_.clear ();
      }

      /// Number of elements on the stack.
      index_type
      size () const YY_NOEXCEPT
      {
        return index_type (seq_.size ());
      }

      /// Iterator on top of the stack (going downwards).
      const_iterator
      begin () const YY_NOEXCEPT
      {
        return seq_.begin ();
      }

      /// Bottom of the stack.
      const_iterator
      end () const YY_NOEXCEPT
      {
        return seq_.end ();
      }

      /// Present a slice of the top of a stack.
      class slice
      {
      public:
        slice (const stack& stack, index_type range)
          : stack_ (stack)
          , range_ (range)
        {}

        const T&
        operator[] (index_type i) const
        {
          return stack_[range_ - i];
        }

      private:
        const stack& stack_;
        index_type range_;
      };

    private:
#if YY_CPLUSPLUS < 201103L
      /// Non copyable.
      stack (const stack&);
      /// Non copyable.
      stack& operator= (const stack&);
#endif
      /// The wrapped container.
      S seq_;
    };


    /// Stack type.
    typedef stack<stack_symbol_type> stack_type;

    /// The stack.
    stack_type yystack_;

    /// Push a new state on the stack.
    /// \param m    a debug message to display
    ///             if null, no trace is output.
    /// \param sym  the symbol
    /// \warning the contents of \a s.value is stolen.
    void yypush_ (const char* m, YY_MOVE_REF (stack_symbol_type) sym);

    /// Push a new look ahead token on the state on the stack.
    /// \param m    a debug message to display
    ///             if null, no trace is output.
    /// \param s    the state
    /// \param sym  the symbol (for its value and location).
    /// \warning the contents of \a sym.value is stolen.
    void yypush_ (const char* m, state_type s, YY_MOVE_REF (symbol_type) sym);

    /// Pop \a n symbols from the stack.
    void yypop_ (int n = 1);

    /// Constants.
    enum
    {
      yylast_ = 4833,     ///< Last index in yytable_.
      yynnts_ = 86,  ///< Number of nonterminal symbols.
      yyfinal_ = 54 ///< Termination state number.
    };


    // User arguments.
    ParserHelper & helper;

  };


#line 9 "parser.y"
} // wtparser
#line 1216 "parser.tab.hpp"




#endif // !YY_YY_PARSER_TAB_HPP_INCLUDED
