#ifndef WTRUNTIME_MICROPROGRAM_H
#define WTRUNTIME_MICROPROGRAM_H

#include "config.h"
#include "wtruntime.h"
#include "types.h"
#include "stdlib.h"

struct wtr_profile;
struct wtr_program;
struct wtr_context;

/* A microprogram returns false if nothing extraordinary happened (i.e. it */
/* was successful) or an I/O operation has been requested (to distinguish */
/* these situations, check the 'th->run' field).. Returns true if an */
/* exception has raised -- in this case the 'th->last_exception' holds */
/* the raised exception. */
typedef enum wtr_runresult (*WTR_PFN_MICROPROGRAM)(
	struct wtr_profile* const prof, struct wtr_program* const prog,
	struct wtr_context* const ctx);

#define __WTR_NAME_MICROPROGRAM(lowercase,UPPERCASE) \
	wtr_mp_##lowercase

#define __WTR_DECLARE_MICROPROGRAM(lowercase,UPPERCASE) \
	enum wtr_runresult __WTR_NAME_MICROPROGRAM(lowercase,UPPERCASE) \
		(struct wtr_profile* const prof, struct wtr_program* const prog, \
		struct wtr_context* const ctx);

extern WTR_PFN_MICROPROGRAM wtr_microprogtab[];

WTR_MICROPROGRAMS(__WTR_DECLARE_MICROPROGRAM)

#endif /* WTRUNTIME_MICROPROGRAM_H */
